//+------------------------------------------------------------------------+
//|                       MTF TSS[sw]                                 ik   |
//|                       default :       MODE_SMA,PRICE_CLOSE             |
//|                                     "http://www.forex-tsd.com"         |
//+------------------------------------------------------------------------+
#property copyright   "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 OrangeRed
#property indicator_color3 Maroon
#property indicator_color4 Olive
#property indicator_color5 MediumOrchid
#property indicator_color6 RoyalBlue
//#property indicator_color7 Purple
//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;
extern int Band1Period=5;
extern int Band2Period=50;
extern int Band3Period=150;
extern int Band4Period=300;
extern int Band5Period=600;
extern int Band6Period=1200;
//Shift
extern int Band1Shift=0;
extern int Band2Shift=0;
extern int Band3Shift=0;
extern int Band4Shift=0;
extern int Band5Shift=0;
extern int Band6Shift=0;
//Ma Mode: SMA_0_EMA1_SMMA2_LWMA3;
extern int Band1Mode=0;
extern int Band2Mode=0;
extern int Band3Mode=0;
extern int Band4Mode=0;
extern int Band5Mode=0;
extern int Band6Mode=0;

//priceClose_0;Open_1; High_2;Low_3;Median_4; Typical_5;WeightedClose_6; 
extern int Band1Price=0 ;
extern int Band2Price=0 ;
extern int Band3Price=0 ;
extern int Band4Price=0 ;
extern int Band5Price=0 ;
extern int Band6Price=0 ;
/***
MAMethod(MODE)
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 

PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4
***/
extern int ____;
extern int Note;
extern int MA_Method;
extern int SMA_0_EMA1_SMMA2_LWMA3;
extern int PRICE;
extern int Close0_Open1_High2_Low3;
extern int priceMedian4__Typical5; 
extern int priceWeightedClose_6; 
//
double ExtBand1Buffer[];
double ExtBand2Buffer[];
double ExtBand3Buffer[];
double ExtBand4Buffer[];
double ExtBand5Buffer[];
double ExtBand6Buffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line

   SetIndexBuffer(0,ExtBand1Buffer);
   SetIndexBuffer(1,ExtBand2Buffer);
   SetIndexBuffer(2,ExtBand3Buffer);  
   SetIndexBuffer(3,ExtBand4Buffer);  
   SetIndexBuffer(4,ExtBand5Buffer);  
   SetIndexBuffer(5,ExtBand6Buffer);  
  
   SetIndexStyle(0,DRAW_LINE);   
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);  
   SetIndexStyle(5,DRAW_LINE);  
      if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,Band1Shift*TimeFrame/Period());
   SetIndexShift(1,Band2Shift*TimeFrame/Period());
   SetIndexShift(2,Band3Shift*TimeFrame/Period());
   SetIndexShift(3,Band4Shift*TimeFrame/Period());
   SetIndexShift(4,Band5Shift*TimeFrame/Period());
   SetIndexShift(5,Band6Shift*TimeFrame/Period());

   SetIndexDrawBegin(0,Band1Shift+Band1Period);
   SetIndexDrawBegin(1,Band2Shift+Band2Period);
   SetIndexDrawBegin(2,Band3Shift+Band3Period);
   SetIndexDrawBegin(3,Band4Shift+Band4Period);
   SetIndexDrawBegin(4,Band5Shift+Band5Period);
   SetIndexDrawBegin(5,Band6Shift+Band6Period);
      
   SetIndexLabel(0,"MTF_TSS SMAcl "+Band1Period+",tf"+TimeFrame+"");
   SetIndexLabel(1,"MTF_TSS SMAcl "+Band2Period+",tf"+TimeFrame+"");
   SetIndexLabel(2,"MTF_TSS SMAcl "+Band3Period+",tf"+TimeFrame+"");
   SetIndexLabel(3,"MTF_TSS SMAcl "+Band4Period+",tf"+TimeFrame+"");
   SetIndexLabel(4,"MTF_TSS SMAcl "+Band5Period+",tf"+TimeFrame+"");
   SetIndexLabel(5,"MTF_TSS SMAcl "+Band6Period+",tf"+TimeFrame+"");
 
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName("MTF_TSStf"+TimeFrame+"");
//   "+Band1Period+","+Band2Period+","+Band3Period+"

 
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,
 //  Band1Shift,Band2Shift,Band3Shift, Band4Shift,
   limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
    
 ExtBand1Buffer[i]=iMA(NULL,TimeFrame,Band1Period,Band1Shift, Band1Mode,Band1Price,y);
 ExtBand2Buffer[i]=iMA(NULL,TimeFrame,Band2Period,Band2Shift, Band2Mode,Band2Price,y);
 ExtBand3Buffer[i]=iMA(NULL,TimeFrame,Band3Period,Band3Shift, Band3Mode,Band3Price,y);
 ExtBand4Buffer[i]=iMA(NULL,TimeFrame,Band4Period,Band4Shift, Band4Mode,Band4Price,y);
 ExtBand5Buffer[i]=iMA(NULL,TimeFrame,Band5Period,Band5Shift, Band5Mode,Band5Price,y);
 ExtBand6Buffer[i]=iMA(NULL,TimeFrame,Band6Period,Band6Shift, Band6Mode,Band6Price,y);

   }  
  
   return(0);
  }
//+------------------------------------------------------------------+